#include <allegro.h>

#include "main.h"
#include "title.h"
#include "gfx.h"

int title_show()
{
	BITMAP *buffer, *title;
	PALETTE pal;
	int choice = 0;
	int k;
	int x,y;

	title = load_bitmap("data/title.pcx", pal);
	set_palette(pal);
			
	for (y=160; y<=196; y++)			
		for (x=96 + (y % 2); x<=224; x+=2)			
				putpixel(title, x,y, makecol(0,0,0));

	rect(title, 95,159, 225, 197, makecol(255,255,255));

	while (1)
	{	
		buffer = gfx_frame_start(gfx);
		blit(title, buffer, 0,0, 0,0, 320,240);

		if (choice == 0)
			textprintf_ex(buffer, font64, 104,168, 0, 15, "* START GAME *");
		else
			textprintf_ex(buffer, font64, 120,168, 15, -1, "START GAME");


		if (choice == 1)
			textprintf_ex(buffer, font64, 112,176, 0, 15, "* WAR ROOM *");
		else
			textprintf_ex(buffer, font64, 128,176, 15, -1, "WAR ROOM");

		if (choice == 2)
			textprintf_ex(buffer, font64, 128,184, 0, 15, "* EXIT *");
		else
			textprintf_ex(buffer, font64, 144,184, 15, -1, "EXIT");


		gfx_frame_end(gfx);

		clear_keybuf();
		k = readkey() >> 8;
		
		if (k == KEY_DOWN)
		{
			choice++;
			play_sample(bop, 255, 128, 1000, 0);
		}
		else if (k == KEY_UP)
		{
			choice--;
			play_sample(bop, 255, 128, 1000, 0);
		}
		else if (k == KEY_ENTER)
		{
			if (choice == 0 && ahahaa) play_sample(ahahaa, 255,128,1000, 0);
			break;
		}
		else if (k == KEY_ESC)
		{
			if (choice != 2) choice = 2;
			else break;
		}

		

		if (choice < 0) choice = 2;
		else if (choice > 2) choice = 0;

		rest(100);
	}

	destroy_bitmap(title);

	return choice;
}

